function edgeTest

x = [-0.5 -0.5 0.5 0.5 0.5 0.7];
y = [-0.5 0.5 0.5 -0.5 1 0.8];
tri = delaunay(x,y,{'Qt','Qbb','Qc','Qz'})

% for i=1:6
%     text(x(i),y(i),int2str(i));
% end
% hold on;

[ntri,nx,ny]=refineTriMesh(tri,x,y);

trimesh(ntri,nx,ny);
%trimesh(tri,x,y);
m = length(nx);

hold on;

for i=1:m
    text(nx(i),ny(i),int2str(i));
end

ntri
edge=createEdges(ntri)

for i=1:m
    for j=i+1:m
        if edge(i,j) == 1
            display(strcat(int2str(i), '->', int2str(j)));
        end
    end
end
