function [z]=initialZ(x,y)

%{
% Cubic surface function
a1=2; a2=2; a3=-1; a4=2;
b1=-1; b2=1; b3=-2;
c1=1; c2=-2; d=0;
z = a1*x.^3 + a2*x.^2.*y + a3*x.*y.^2 + a4*y.^3 +...
    b1*x.^2 + b2*x.*y + b3*y.^2 +...
    c1*x + c2*y + d;
%}

% matlab peaks() function
% surf(peaks(35)) 

z =  3*(1-x).^2.*exp(-(x.^2) - (y+1).^2) ... 
   - 10*(x/5 - x.^3 - y.^5).*exp(-x.^2-y.^2) ... 
   - 1/3*exp(-(x+1).^2 - y.^2);


end