function [ntri,nx,ny,nw]=refineTriDataNew(tri,x,y,w)

len = length(x);
edge = zeros(len,len);
r = size(tri,1);

nx = x;
ny = y;
ntri = [];
cnt = len;

for i=1:r

    if edge(tri(i,1),tri(i,2)) == 0
        cnt = cnt + 1;
        nx = [nx (x(tri(i,1)) + x(tri(i,2)))/2];
        ny = [ny (y(tri(i,1)) + y(tri(i,2)))/2];
        edge(tri(i,1),tri(i,2)) = cnt;
        edge(tri(i,2),tri(i,1)) = cnt;
    end
    if edge(tri(i,2),tri(i,3)) == 0
        cnt = cnt + 1;
        nx = [nx (x(tri(i,2)) + x(tri(i,3)))/2];
        ny = [ny (y(tri(i,2)) + y(tri(i,3)))/2];
        edge(tri(i,2),tri(i,3)) = cnt;
        edge(tri(i,3),tri(i,2)) = cnt;
    end
    if edge(tri(i,3),tri(i,1)) == 0
        cnt = cnt + 1;
        nx = [nx (x(tri(i,3)) + x(tri(i,1)))/2];
        ny = [ny (y(tri(i,3)) + y(tri(i,1)))/2];
        edge(tri(i,3),tri(i,1)) = cnt;
        edge(tri(i,1),tri(i,3)) = cnt;
    end

    mida = edge(tri(i,1),tri(i,2));
    midb = edge(tri(i,2),tri(i,3));
    midc = edge(tri(i,3),tri(i,1));

    ntri = [ntri; tri(i,1), mida, midc; ...
        mida, tri(i,2), midb; ...
        midb, tri(i,3), midc;...
        mida, midb, midc];
end

obv=boundaryVertices(tri);

olen = length(x);
isbd=zeros(1,olen);
isbd(obv)=1;
oiv =[];
%inner vertices are in iv
for i=1:olen
    if isbd(i) == 0
        oiv=[oiv i];
    end
end
% if isbd is 0 it is inner vertex or else it is boundary vertex

nw = zeros(olen, 2);

P=[1, -435/256; 0, -91/256];
B=[3/8, 0; -47/512, 69/512];
C=[1/8, 0; -17/512, -5/512];
D=[0, 145/512; 0, -45/512];

oST=starShape(tri);

oivlen = length(oiv);

for i=1:oivlen
    olocalStar = trimEndZeros(oST(:,3*oiv(i)-2:3*oiv(i)));
    deg = size(olocalStar,1);
    olocalbv=boundaryVertices(olocalStar);

    oappedge=createEdges(tri);
    owsum = zeros(1,2);

    if deg == 6

        for k=1:6
            z = [];
            owsum = owsum + w(olocalbv(k),:);
            [r,c,v]=find(olocalStar == olocalbv(k));
            tmp = olocalStar(r,:);
            for b=1:size(tmp,1)
                for c=1:size(tmp,2)
                    if tmp(b,c) ~= oiv(i) && tmp(b,c) ~=olocalbv(k)
                        %                    z=[z tmp(b,c)]; % i have the other vertices....
                        nwsum = nwsum + w(tmp(b,c),:)
                    end
                end
            end
            %% the new w value is done...
            nw(edge(oiv(i),olocalbv(k)),:) = nwsum * C + ( w(oiv(i),:) + w(olocalbv(k),:) ) * B;
        end
        nw(oiv(i),:) = w(oiv(i),:)*P + owsum*D;

    else
        %%% !=6.....
        a=5/8-(3/8+(1/4)*cos(2*pi/deg))*(3/8+(1/4)*cos(2*pi/deg));
        Q=[1, a*(-145/31); 0, -a];
        A=(512/31)*a*D;
        for k=1:length(olocalbv)
            z = [];
            owsum = owsum + w(olocalbv(k),:);
            [r,c,v]=find(olocalStar == olocalbv(k));
            tmp = olocalStar(r,:);
            for b=1:size(tmp,1)
                for c=1:size(tmp,2)
                    if tmp(b,c) ~= oiv(i) && tmp(b,c) ~=olocalbv(k)
                        %                    z=[z tmp(b,c)]; % i have the other vertices....
                        nwsum = nwsum + w(tmp(b,c),:)
                    end
                end
            end
            nw(edge(oiv(i),olocalbv(k)),:) = nwsum * C + ( w(oiv(i),:) + w(olocalbv(k),:) ) * B;
        end

        nw(oiv(i),:) = w(oiv(i),:)*Q + owsum*A/deg;
    end
end

