%% InterpolatorySubdivisionDemo
% This demo simply runs a restricted form of our GUI tool for fitting an
% Interpolatory Subdivision in % MATLAB. 
%
% This is part of a tool that we use to explore interpolatory subdivision
% patch fitting decisions before implementing them as StreamingModules?.
%
%% Install
% Unzip the file and point MATLAB to the directory. Data included in
% tempPadj.mat is from the bathymetric data supplied by Rob Anderson.

%% Instructions
% In MATLAB, type demoInterpFit to run the demo. Data included in
% tempPadj.mat is from the bathymetric data supplied by Rob Anderson is
% loaded. Then you click the "find P" button to find the parameters of the
% interpolatory subdivision P; MATLAB prints the time; on my laptop, it
% takes about 10 seconds. (This is a prototype for the faster
% implementation as StreamingModules?) Then you click the "refinement
% steps" button. To also see the original data click "show sample points".

GlobalCubicSurfacenewnew