function [ntri,nx,ny]=refineTriMesh(tri,x,y)

len = length(x);
edge = zeros(len,len);
r = size(tri,1);

nx = x;
ny = y;
ntri = [];
cnt = len;

for i=1:r
    
    if edge(tri(i,1),tri(i,2)) == 0
        cnt = cnt + 1;
        nx = [nx (x(tri(i,1)) + x(tri(i,2)))/2];
        ny = [ny (y(tri(i,1)) + y(tri(i,2)))/2];
        edge(tri(i,1),tri(i,2)) = cnt;
        edge(tri(i,2),tri(i,1)) = cnt;
    end
    if edge(tri(i,2),tri(i,3)) == 0
        cnt = cnt + 1;
        nx = [nx (x(tri(i,2)) + x(tri(i,3)))/2];
        ny = [ny (y(tri(i,2)) + y(tri(i,3)))/2];
        edge(tri(i,2),tri(i,3)) = cnt;
        edge(tri(i,3),tri(i,2)) = cnt;
    end
    if edge(tri(i,3),tri(i,1)) == 0
        cnt = cnt + 1;
        nx = [nx (x(tri(i,3)) + x(tri(i,1)))/2];
        ny = [ny (y(tri(i,3)) + y(tri(i,1)))/2];
        edge(tri(i,3),tri(i,1)) = cnt;
        edge(tri(i,1),tri(i,3)) = cnt;
    end
    
    mida = edge(tri(i,1),tri(i,2));
    midb = edge(tri(i,2),tri(i,3));
    midc = edge(tri(i,3),tri(i,1));
    
    ntri = [ntri; tri(i,1), mida, midc; ...
        mida, tri(i,2), midb; ...
        midb, tri(i,3), midc;...
        mida, midb, midc];
end